#include <Narcoleptic.h>
#define dw digitalWrite
#define dm delayMicroseconds

const int XAXIS1 = 8;	// Blue   - 28BYJ48 pin 1
const int XAXIS2 = 9;	// Pink   - 28BYJ48 pin 2
const int XAXIS3 = 10;	// Yellow - 28BYJ48 pin 3
const int XAXIS4 = 11;	// Orange - 28BYJ48 pin 4

const int YAXIS1 = 4;	// Blue   - 28BYJ48 pin 1
const int YAXIS2 = 5;	// Pink   - 28BYJ48 pin 2
const int YAXIS3 = 6;	// Yellow - 28BYJ48 pin 3
const int YAXIS4 = 7;	// Orange - 28BYJ48 pin 4
                        // Red    - 28BYJ48 pin 5 VCC
const int mp1 = 0;	// Blue   - 28BYJ48 pin 1
const int mp2 = 0;	// Pink   - 28BYJ48 pin 2
const int mp3 = 0;	// Yellow - 28BYJ48 pin 3
const int mp4 = 0;

int motorSpeed=3000;    // set stepper speed, period actually
int stepnum=0;
int Ystepnum=0;
int Xstepnum=0;          // current microstep 0-7
float err=0;            // running total of movedeg - requested move, always negative in degrpm()
int ar[8];              // assigned in ccw() only, to detect abnormal torque load
int movecnt=0; 
int Xmovecnt=0; 
int Ymovecnt=0; // running total of steps taken in move(), &=4095 in moveto
long m;                 // millis()
int step2,d;            // nowait
int ii,k;

void setup() {
  pinMode(XAXIS1, OUTPUT);
  pinMode(XAXIS2, OUTPUT);
  pinMode(XAXIS3, OUTPUT);
  pinMode(XAXIS4, OUTPUT);
  pinMode(YAXIS1, OUTPUT);
  pinMode(YAXIS2, OUTPUT);
  pinMode(YAXIS3, OUTPUT);
  pinMode(YAXIS4, OUTPUT);
  pinMode(13, OUTPUT);  //onboard LED
  //Serial.begin(115200);
  //degrpmslowCool4_nowait(0,180*100,1000); //10RPH
  //degrpm_nowait(1,180*100,1500);
  pinMode(3, OUTPUT);
  dw(3, HIGH);
  Serial.begin(9600);
}

int incomingByte = 0;
String strY;
String strX;

int taskNum = 0;

void loop(){
	float xLoc, yLoc;
	const float STEPERDEG=float(64)*64/360;

          //random laser cat-play!
          //moveXto(STEPERDEG*random(180)-360);
          //moveYto(STEPERDEG*random(45)-90);
          //splitUp(random(60),random(40), 1);


       
        boolean thisWasMovement = false;
       
       if (Serial.available()){
         //Serial.print("Reading: ");
          boolean xRead = false;
          delay(100); // Wait for all data.
          while (Serial.available()) {
              char d = Serial.read();
              thisWasMovement = false;
              //do action based on special input
              if(d=='w')
              {
                 moveY(1);
                 //yOff();
                 setTopLeft();
              }
              if(d=='s')
              {
                 moveY(0);
                // yOff();
                 setTopLeft();
              }
              if(d=='a')
              {
                 moveX(1);
                // xOff();
                 setTopLeft();
              }
              if(d=='d')
              {
                 moveX(0);
               //  xOff();
                 setTopLeft();
              }
              
              if(d=='W')
              {
                
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 moveY(1);
                 //yOff();
                 setTopLeft();
              }
              if(d=='S')
              {
                 moveY(0);
                 moveY(0);
                 moveY(0);
                 moveY(0);
                 moveY(0);
                 moveY(0);
                 moveY(0);
                 moveY(0);
                 moveY(0);
                 moveY(0);
                 moveY(0);
                 moveY(0);
                 moveY(0);
                 moveY(0);
                 moveY(0);
                 moveY(0);
                // yOff();
                 setTopLeft();
              }
              if(d=='A')
              {
                 moveX(1);
                 moveX(1);
                 moveX(1);
                 moveX(1);
                 moveX(1);
                 moveX(1);
                 moveX(1);
                 moveX(1);
                 moveX(1);
                 moveX(1);
                 moveX(1);
                 moveX(1);
                 moveX(1);
                 moveX(1);
                 moveX(1);
                 moveX(1);
                // xOff();
                 setTopLeft();
              }
              if(d=='D')
              {
                 moveX(0);
                 moveX(0);
                 moveX(0);
                 moveX(0);
                 moveX(0);
                 moveX(0);
                 moveX(0);
                 moveX(0);
                 moveX(0);
                 moveX(0);
                 moveX(0);
                 moveX(0);
                 moveX(0);
                 moveX(0);
                 moveX(0);
                 moveX(0);
                // xOff();
                 setTopLeft();
              }
              
              
              
              
              if(d=='r')
              {
                 setTopLeft();
                 xOff();
                 yOff();
              }
              if(d=='o')
              {
                 dw(3, LOW); 
              }
              if(d=='i')
              {
                 dw(3, HIGH); 
              }
              
              
              if(d=='*')
              {
                d=' ';

                motorSpeed = strX.toInt();
                
                strX = "";

		
              }
              
              if(d==',')
              {
                xRead = true;
                d=' ';
              }
              if(xRead)
                strY.concat(d);
              else
                strX.concat(d);
          }
          //int Xvalue = strX.toInt();
          //int Yvalue = strY.toInt();
		  
		  char charstrX[strX.length()+1];
		  char charstrY[strY.length()+1];
		  strX.toCharArray(charstrX, strX.length());
		  strY.toCharArray(charstrY, strY.length());
		  
		  
		  float Xvalue = atof(charstrX);
		  float Yvalue = atof(charstrY);
		  
		  if(taskNum>2000)
		    taskNum = 0;
			
		  taskNum++;
		
		  
                  if(strY != "")
                  {
                    splitUp(Xvalue,Yvalue, taskNum);
                    xOff();
                    yOff();
                    Serial.write("dun");
                  }
                  else
                    Serial.write("adj");
          strY = "";
          strX = "";
      }
      
      
      
}
void setTopLeft(){
  Xmovecnt = 0;
  Ymovecnt = 0;
}

void splitUp(float xLoc, float yLoc, int thisTaskNum){
	//Xmovecnt, Ymovecnt  num steps taken
	//STEPERDEG is steps per degree

	//TODO: Implement tasknum check to prevent pointless movement
	




	const float STEPERDEG=float(64)*64/360;
/*
        moveXto(xLoc*STEPERDEG);
        xOff();
        moveYto(yLoc*STEPERDEG);
        yOff();
*/	
	int desiredXsteps = xLoc*STEPERDEG;
	int desiredYsteps = yLoc*STEPERDEG;
	
	int stepDiffX = Xmovecnt - desiredXsteps;
	int stepDiffY = Ymovecnt - desiredYsteps;
	
	int dirX;
	int dirY;
	
	//determine direction of movement for each
	if(stepDiffX<0)
		dirX = 1;
	else
		dirX = -1;
	if(stepDiffY<0)
		dirY = 1;
	else
		dirY = -1;
	
	int stepsXhere = 0;
	int stepsYhere = 0;
	
	boolean stillMoving = true;
	while(stillMoving){
		
		if(stepsXhere < abs(stepDiffX))
		{
            moveXto(Xmovecnt+dirX);
            //xOff();
			stepsXhere++;
		}
		if(stepsYhere < abs(stepDiffY))
		{
			moveYto(Ymovecnt+dirY);
            //yOff();
			stepsYhere++;
		}
		if(stepsXhere == abs(stepDiffX) && stepsYhere == abs(stepDiffY))
			stillMoving = false;
	}

}




//call like this moveto(90.0*STEPERDEG);
//code decides which direction to move is shortest
void moveXto(int steppos){
	steppos&=4095;
	Xmovecnt&=4095; //this will not happen in move() can be >4096
	int bcw=0;
	if(steppos>Xmovecnt)bcw=1;
	if(abs(steppos-Xmovecnt)>2048)bcw=!bcw;
	moveXtodir(bcw,steppos);
}
void moveYto(int steppos){
steppos&=4095;
movecnt&=4095; //this will not happen in move() can be >4096
int bcw=0;
if(steppos>Ymovecnt)bcw=1;
if(abs(steppos-Ymovecnt)>2048)bcw=!bcw;
moveYtodir(bcw,steppos);
}

void moveXtodir(boolean bcw, int steppos){
//absolute position you decide direction
steppos&=4095;
Xmovecnt&=4095; //this will not happen in move() can be >4096 or <0
while(Xmovecnt!=steppos) {
  moveX(bcw);
  Xmovecnt&=4095;
  }
//can turn off()
}

void moveYtodir(boolean bcw, int steppos){
//absolute position you decide direction
steppos&=4095;
Ymovecnt&=4095; //this will not happen in move() can be >4096 or <0
while(Ymovecnt!=steppos) {
  moveY(bcw);
  movecnt&=4095;
  }
//can turn off()
}

void moveX(boolean bcw){
if(bcw)Xstepnum++; else Xstepnum--;
if(bcw)Xmovecnt++; else Xmovecnt--;
stepXAXIS();
//if(movecnt%16==1)Serial.println(float(movecnt)*360/64/64);
}

void moveY(boolean bcw){

if(bcw)Ystepnum++; else Ystepnum--;
if(bcw)Ymovecnt++; else Ymovecnt--;
stepYAXIS();
//if(movecnt%16==1)Serial.println(float(movecnt)*360/64/64);
}

//Turn off for cooler motors
void xOff(){
  dw(XAXIS1, LOW);
  dw(XAXIS2, LOW);
  dw(XAXIS3, LOW);
  dw(XAXIS4, LOW);
}
void yOff(){
  dw(YAXIS1, LOW);
  dw(YAXIS2, LOW);
  dw(YAXIS3, LOW);
  dw(YAXIS4, LOW);
}

void stepXAXIS(){
if(Xstepnum==-1)Xstepnum=7;
if(Xstepnum== 8)Xstepnum=0;
switch(Xstepnum){
case 0:
  dw(XAXIS4, HIGH);
  dw(XAXIS3, LOW);
  dw(XAXIS2, LOW);
  dw(XAXIS1, LOW);
  break;
case 1:
  dw(XAXIS4, HIGH);
  dw(XAXIS3, HIGH);
  dw(XAXIS2, LOW);
  dw(XAXIS1, LOW);
  break;
case 2:
  dw(XAXIS4, LOW);
  dw(XAXIS3, HIGH);
  dw(XAXIS2, LOW);
  dw(XAXIS1, LOW);
  break;
case 3:
  dw(XAXIS4, LOW);
  dw(XAXIS3, HIGH);
  dw(XAXIS2, HIGH);
  dw(XAXIS1, LOW);
  break;
case 4:
  dw(XAXIS4, LOW);
  dw(XAXIS3, LOW);
  dw(XAXIS2, HIGH);
  dw(XAXIS1, LOW);
  break;
case 5:
  dw(XAXIS4, LOW);
  dw(XAXIS3, LOW);
  dw(XAXIS2, HIGH);
  dw(XAXIS1, HIGH);
  break;
case 6:
  dw(XAXIS4, LOW);
  dw(XAXIS3, LOW);
  dw(XAXIS2, LOW);
  dw(XAXIS1, HIGH);
  break;
case 7:
  dw(XAXIS4, HIGH);
  dw(XAXIS3, LOW);
  dw(XAXIS2, LOW);
  dw(XAXIS1, HIGH);
  break;
}
//for all cases
dm(motorSpeed);
}


void stepYAXIS(){
if(Ystepnum==-1)Ystepnum=7;
if(Ystepnum== 8)Ystepnum=0;
switch(Ystepnum){
case 0:
  dw(YAXIS4, HIGH);
  dw(YAXIS3, LOW);
  dw(YAXIS2, LOW);
  dw(YAXIS1, LOW);
  break;
case 1:
  dw(YAXIS4, HIGH);
  dw(YAXIS3, HIGH);
  dw(YAXIS2, LOW);
  dw(YAXIS1, LOW);
  break;
case 2:
  dw(YAXIS4, LOW);
  dw(YAXIS3, HIGH);
  dw(YAXIS2, LOW);
  dw(YAXIS1, LOW);
  break;
case 3:
  dw(YAXIS4, LOW);
  dw(YAXIS3, HIGH);
  dw(YAXIS2, HIGH);
  dw(YAXIS1, LOW);
  break;
case 4:
  dw(YAXIS4, LOW);
  dw(YAXIS3, LOW);
  dw(YAXIS2, HIGH);
  dw(YAXIS1, LOW);
  break;
case 5:
  dw(YAXIS4, LOW);
  dw(YAXIS3, LOW);
  dw(YAXIS2, HIGH);
  dw(YAXIS1, HIGH);
  break;
case 6:
  dw(YAXIS4, LOW);
  dw(YAXIS3, LOW);
  dw(YAXIS2, LOW);
  dw(YAXIS1, HIGH);
  break;
case 7:
  dw(YAXIS4, HIGH);
  dw(YAXIS3, LOW);
  dw(YAXIS2, LOW);
  dw(YAXIS1, HIGH);
  break;
}
//for all cases
dm(motorSpeed);
}

